JspWriter (JSP 2.3 API Documentation - Apache Tomcat 9.0.120)
Description: declaration: package: javax.servlet.jsp, class: JspWriter

# Class JspWriter

java.lang.Object
java.io.Writer
javax.servlet.jsp.JspWriter

All Implemented Interfaces:
  `Closeable, Flushable, Appendable, AutoCloseable`

Direct Known Subclasses:
  `BodyContent`

public abstract class JspWriter extends Writer

The actions and template data in a JSP page is written using the JspWriter object that is referenced by the implicit variable out which is initialized automatically using methods in the PageContext object.

This abstract class emulates some of the functionality found in the java.io.BufferedWriter and java.io.PrintWriter classes, however it differs in that it throws IOException from the print methods while PrintWriter does not.

Buffering

The initial JspWriter object is associated with the PrintWriter object of the ServletResponse in a way that depends on whether the page is or is not buffered. If the page is not buffered, output written to this JspWriter object will be written through to the PrintWriter directly, which will be created if necessary by invoking the getWriter() method on the response object. But if the page is buffered, the PrintWriter object will not be created until the buffer is flushed and operations like setContentType() are legal. Since this flexibility simplifies programming substantially, buffering is the default for JSP pages.

Buffering raises the issue of what to do when the buffer is exceeded. Two approaches can be taken:

- Exceeding the buffer is not a fatal error; when the buffer is exceeded, just flush the output.
- Exceeding the buffer is a fatal error; when the buffer is exceeded, raise an exception.

Both approaches are valid, and thus both are supported in the JSP technology. The behavior of a page is controlled by the autoFlush attribute, which defaults to true. In general, JSP pages that need to be sure that correct and complete data has been sent to their client may want to set autoFlush to false, with a typical case being that where the client is an application itself. On the other hand, JSP pages that send data that is meaningful even when partially constructed may want to set autoFlush to true; such as when the data is sent for immediate display through a browser. Each application will need to consider their specific needs.

An alternative considered was to make the buffer size unbounded; but, this had the disadvantage that runaway computations would consume an unbounded amount of resources.

The "out" implicit variable of a JSP implementation class is of this type. If the page directive selects autoflush="true" then all the I/O operations on this class shall automatically flush the contents of the buffer if an overflow condition would result if the current operation were performed without a flush. If autoflush="false" then all the I/O operations on this class shall throw an IOException if performing the current operation would result in a buffer overflow condition.

See Also:
  - `Writer`
  - `BufferedWriter`
  - `PrintWriter`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected boolean`
  `autoFlush`
  Whether the JspWriter is autoflushing.
  `protected int`
  `bufferSize`
  The size of the buffer used by the JspWriter.
  `static final int`
  `DEFAULT_BUFFER`
  Constant indicating that the Writer is buffered and is using the implementation default buffer size.
  `static final int`
  `NO_BUFFER`
  Constant indicating that the Writer is not buffering output.
  `static final int`
  `UNBOUNDED_BUFFER`
  Constant indicating that the Writer is buffered and is unbounded; this is used in BodyContent.

  ### Fields inherited from class Writer

  `lock`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `JspWriter(int bufferSize, boolean autoFlush)`
  Protected constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract void`
  `clear()`
  Clear the contents of the buffer.
  `abstract void`
  `clearBuffer()`
  Clears the current contents of the buffer.
  `abstract void`
  `close()`
  Close the stream, flushing it first.
  `abstract void`
  `flush()`
  Flush the stream.
  `int`
  `getBufferSize()`
  This method returns the size of the buffer used by the JspWriter.
  `abstract int`
  `getRemaining()`
  This method returns the number of unused bytes in the buffer.
  `boolean`
  `isAutoFlush()`
  This method indicates whether the JspWriter is autoFlushing.
  `abstract void`
  `newLine()`
  Write a line separator.
  `abstract void`
  `print(boolean b)`
  Print a boolean value.
  `abstract void`
  `print(char c)`
  Print a character.
  `abstract void`
  `print(char[] s)`
  Print an array of characters.
  `abstract void`
  `print(double d)`
  Print a double-precision floating-point number.
  `abstract void`
  `print(float f)`
  Print a floating-point number.
  `abstract void`
  `print(int i)`
  Print an integer.
  `abstract void`
  `print(long l)`
  Print a long integer.
  `abstract void`
  `print(Object obj)`
  Print an object.
  `abstract void`
  `print(String s)`
  Print a string.
  `abstract void`
  `println()`
  Terminate the current line by writing the line separator string.
  `abstract void`
  `println(boolean x)`
  Print a boolean value and then terminate the line.
  `abstract void`
  `println(char x)`
  Print a character and then terminate the line.
  `abstract void`
  `println(char[] x)`
  Print an array of characters and then terminate the line.
  `abstract void`
  `println(double x)`
  Print a double-precision floating-point number and then terminate the line.
  `abstract void`
  `println(float x)`
  Print a floating-point number and then terminate the line.
  `abstract void`
  `println(int x)`
  Print an integer and then terminate the line.
  `abstract void`
  `println(long x)`
  Print a long integer and then terminate the line.
  `abstract void`
  `println(Object x)`
  Print an Object and then terminate the line.
  `abstract void`
  `println(String x)`
  Print a String and then terminate the line.

  ### Methods inherited from class Writer

  `append, append, append, nullWriter, write, write, write, write, write`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### NO_BUFFER

    public static final int NO_BUFFER
    Constant indicating that the Writer is not buffering output.
    See Also:
      - Constant Field Values

  - ### DEFAULT_BUFFER

    public static final int DEFAULT_BUFFER
    Constant indicating that the Writer is buffered and is using the implementation default buffer size.
    See Also:
      - Constant Field Values

  - ### UNBOUNDED_BUFFER

    public static final int UNBOUNDED_BUFFER
    Constant indicating that the Writer is buffered and is unbounded; this is used in BodyContent.
    See Also:
      - Constant Field Values

  - ### bufferSize

    protected int bufferSize
    The size of the buffer used by the JspWriter.

  - ### autoFlush

    protected boolean autoFlush
    Whether the JspWriter is autoflushing.

- ## Constructor Details

  - ### JspWriter

    protected JspWriter(int bufferSize, boolean autoFlush)
    Protected constructor.
    Parameters:
      `bufferSize` - the size of the buffer to be used by the JspWriter
      `autoFlush` - whether the JspWriter should be autoflushing

- ## Method Details

  - ### newLine

    public abstract void newLine() throws IOException
    Write a line separator. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline ('\n') character.
    Throws:
      `IOException` - If an I/O error occurs

  - ### print

    public abstract void print(boolean b) throws IOException
    Print a boolean value. The string produced by ``String.valueOf(boolean)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `b` - The `boolean` to be printed
    Throws:
      `IOException` - If an error occurred while writing

  - ### print

    public abstract void print(char c) throws IOException
    Print a character. The character is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `c` - The `char` to be printed
    Throws:
      `IOException` - If an error occurred while writing

  - ### print

    public abstract void print(int i) throws IOException
    Print an integer. The string produced by ``String.valueOf(int)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `i` - The `int` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Integer.toString(int)`

  - ### print

    public abstract void print(long l) throws IOException
    Print a long integer. The string produced by ``String.valueOf(long)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `l` - The `long` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Long.toString(long)`

  - ### print

    public abstract void print(float f) throws IOException
    Print a floating-point number. The string produced by ``String.valueOf(float)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `f` - The `float` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Float.toString(float)`

  - ### print

    public abstract void print(double d) throws IOException
    Print a double-precision floating-point number. The string produced by ``String.valueOf(double)`` is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `d` - The `double` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Double.toString(double)`

  - ### print

    public abstract void print(char[] s) throws IOException
    Print an array of characters. The characters are written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `s` - The array of chars to be printed
    Throws:
      `NullPointerException` - If `s` is `null`
      `IOException` - If an error occurred while writing

  - ### print

    public abstract void print(String s) throws IOException
    Print a string. If the argument is `null` then the string `"null"` is printed. Otherwise, the string's characters are written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `s` - The `String` to be printed
    Throws:
      `IOException` - If an error occurred while writing

  - ### print

    public abstract void print(Object obj) throws IOException
    Print an object. The string produced by the ``String.valueOf(Object)`` method is written to the JspWriter's buffer or, if no buffer is used, directly to the underlying writer.
    Parameters:
      `obj` - The `Object` to be printed
    Throws:
      `IOException` - If an error occurred while writing
    See Also:
      - `Object.toString()`

  - ### println

    public abstract void println() throws IOException
    Terminate the current line by writing the line separator string. The line separator string is defined by the system property `line.separator`, and is not necessarily a single newline character (`'\n'`).
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(boolean x) throws IOException
    Print a boolean value and then terminate the line. This method behaves as though it invokes ``print(boolean)`` and then ``println()``.
    Parameters:
      `x` - the boolean to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(char x) throws IOException
    Print a character and then terminate the line. This method behaves as though it invokes ``print(char)`` and then ``println()`` .
    Parameters:
      `x` - the char to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(int x) throws IOException
    Print an integer and then terminate the line. This method behaves as though it invokes ``print(int)`` and then ``println()`` .
    Parameters:
      `x` - the int to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(long x) throws IOException
    Print a long integer and then terminate the line. This method behaves as though it invokes ``print(long)`` and then ``println()``.
    Parameters:
      `x` - the long to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(float x) throws IOException
    Print a floating-point number and then terminate the line. This method behaves as though it invokes ``print(float)`` and then ``println()``.
    Parameters:
      `x` - the float to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(double x) throws IOException
    Print a double-precision floating-point number and then terminate the line. This method behaves as though it invokes ``print(double)`` and then ``println()``.
    Parameters:
      `x` - the double to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(char[] x) throws IOException
    Print an array of characters and then terminate the line. This method behaves as though it invokes `print(char[])` and then `println()`.
    Parameters:
      `x` - the char[] to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(String x) throws IOException
    Print a String and then terminate the line. This method behaves as though it invokes ``print(String)`` and then ``println()``.
    Parameters:
      `x` - the String to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### println

    public abstract void println(Object x) throws IOException
    Print an Object and then terminate the line. This method behaves as though it invokes ``print(Object)`` and then ``println()``.
    Parameters:
      `x` - the Object to write
    Throws:
      `IOException` - If an error occurred while writing

  - ### clear

    public abstract void clear() throws IOException
    Clear the contents of the buffer. If the buffer has been already been flushed then the clear operation shall throw an IOException to signal the fact that some data has already been irrevocably written to the client response stream.
    Throws:
      `IOException` - If an I/O error occurs

  - ### clearBuffer

    public abstract void clearBuffer() throws IOException
    Clears the current contents of the buffer. Unlike clear(), this method will not throw an IOException if the buffer has already been flushed. It merely clears the current content of the buffer and returns.
    Throws:
      `IOException` - If an I/O error occurs

  - ### flush

    public abstract void flush() throws IOException
    Flush the stream. If the stream has saved any characters from the various write() methods in a buffer, write them immediately to their intended destination. Then, if that destination is another character or byte stream, flush it. Thus one flush() invocation will flush all the buffers in a chain of Writers and OutputStreams.

    The method may be invoked indirectly if the buffer size is exceeded.

    Once a stream has been closed, further write() or flush() invocations will cause an IOException to be thrown.

    Specified by:
      `flush` in interface `Flushable`
    Specified by:
      `flush` in class `Writer`
    Throws:
      `IOException` - If an I/O error occurs

  - ### close

    public abstract void close() throws IOException
    Close the stream, flushing it first.

    This method needs not be invoked explicitly for the initial JspWriter as the code generated by the JSP container will automatically include a call to close().

    Closing a previously-closed stream, unlike flush(), has no effect.

    Specified by:
      `close` in interface `AutoCloseable`
    Specified by:
      `close` in interface `Closeable`
    Specified by:
      `close` in class `Writer`
    Throws:
      `IOException` - If an I/O error occurs

  - ### getBufferSize

    public int getBufferSize()
    This method returns the size of the buffer used by the JspWriter.
    Returns:
      the size of the buffer in bytes, or 0 is unbuffered.

  - ### getRemaining

    public abstract int getRemaining()
    This method returns the number of unused bytes in the buffer.
    Returns:
      the number of bytes unused in the buffer

  - ### isAutoFlush

    public boolean isAutoFlush()
    This method indicates whether the JspWriter is autoFlushing.
    Returns:
      if this JspWriter is auto flushing or throwing IOExceptions on buffer overflow conditions